<?php 
require_once('../modelos/Difunto.php');

$difunto=new Difunto();

$idpersona=isset($_POST["idpersona"])? limpiarCadena($_POST["idpersona"]):"";
$iddifunto=isset($_POST["iddifunto"])? limpiarCadena($_POST["iddifunto"]):"";
$nombre=isset($_POST["nombre"])? limpiarCadena($_POST["nombre"]):"";
$idtipo_documento=isset($_POST["idtipo_documento"])? limpiarCadena($_POST["idtipo_documento"]):"";
$num_documento=isset($_POST["num_documento"])? limpiarCadena($_POST["num_documento"]):"";
$estado=isset($_POST["estado"])? limpiarCadena($_POST["estado"]):"";
$descripcion_fallecimiento=isset($_POST["descripcion_fallecimiento"])? limpiarCadena($_POST["descripcion_fallecimiento"]):"";
$fecha_fallecimiento=isset($_POST["fecha_fallecimiento"])? limpiarCadena($_POST["fecha_fallecimiento"]):"";
$fecha_entierro=isset($_POST["fecha_entierro"])? limpiarCadena($_POST["fecha_entierro"]):"";


switch ($_GET["op"])
{

    case 'guardaryeditar_difunto':
      if(empty($iddifunto))
      {
        $rspta=$difunto->insertar($nombre,$idtipo_documento,$num_documento,$descripcion_fallecimiento,$fecha_fallecimiento,$fecha_entierro,$estado);
        echo $rspta ? "Difunto Registrado" : "Difunto no se pudo registrar";
      }
      else {
        {
          $rspta=$difunto->editar($iddifunto,$nombre,$idtipo_documento,$num_documento,$descripcion_fallecimiento,$fecha_fallecimiento,$fecha_entierro,$estado);
          echo $rspta ? "Difunto Actualizada" : "Difunto no se pudo actualizar";
        }
      }
    break;

    case 'guardarDifunto':
        $rspta=$difunto->insertar_difunto($nombre,$idtipo_documento,$num_documento);
        echo $rspta ? "Difunto Registrado" : "Difunto no se pudo registrar";
    break;

    case 'mostrar':
      $rspta=$difunto->mostrar($iddifunto);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;

    case 'eliminar':
      $rspta=$difunto->eliminar($iddifunto);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;

     case 'listardifunto':
      $rspta=$difunto->listardifunto();
      //Vamos a declarar un array
      $data=Array();
      while($reg=$rspta->fetch_object())
      {
        $estado = ($reg->estado == 1) 
            ? '<button class="btn btn-success btn-xs btn-flat">Enterrado</button>' 
            : '<button class="btn btn-danger btn-xs btn-flat">Inactiva</button>';
        $data[]=array(
          "0"=>$reg->iddifunto,
          "1"=>$reg->nombre,
          "2"=>$reg->nombredocumento,
          "3"=>$reg->num_documento,
          "4"=>$reg->descripcion_fallecimiento,
          "5"=>$reg->fecha_fallecimiento,
          "6"=>$reg->fecha_entierro,
          "7"=>$estado,
          "8"=>'<a href="create.php?iddifunto=' . $reg->iddifunto . '" class="btn btn-warning btn-xs btn-flat"><i class="fa fa-edit"></i></a>' .
          ' <button class="btn btn-danger btn-xs btn-flat" onclick="eliminar(' . $reg->iddifunto . ')"><i class="fas fa-trash-alt"></i></button>'
        );
      }
      $results= array(
        "sEcho"=>1, //Informacion para el datatable
        "iTotalRecords"=>count($data),//Enviamos el total de registtros en el datatable
        "iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
        "aaData"=>$data);
      echo json_encode($results);

    break;

      case 'selectDifunto':
          $rspta = $difunto->selectDifunto();
          if ($rspta) {
            while ($reg = $rspta->fetch_object()) {
                //echo "<option value='" . htmlspecialchars($reg->idpersona, ENT_QUOTES, 'UTF-8') . "'>" . htmlspecialchars($reg->nombre, ENT_QUOTES, 'UTF-8') . "</option>";
                echo "<option value='" . htmlspecialchars($reg->iddifunto, ENT_QUOTES, 'UTF-8') . "'>" . htmlspecialchars($reg->nombre, ENT_QUOTES, 'UTF-8') . " </option>";
            }
        } else {
            echo "<option value=''>No hay difunto disponibles</option>";
        }
        break;

        case 'autocomplete':
          $term = isset($_GET['term']) ? trim($_GET['term']) : '';
          $rspta = $difunto->buscar_por_nombre($term); // crea esta función en tu modelo

          $datos = [];
          while ($row = $rspta->fetch_assoc()) {
              $datos[] = [
                  "id" => $row['iddifunto'],
                  "label" => $row['nombre'], // o nombre completo
                  "value" => $row['nombre']
              ];
          }
          echo json_encode($datos);
          break;

          case 'ubicacion_difunto':
          $nombre = isset($_POST['nombre']) ? trim($_POST['nombre']) : '';
          $rspta = $difunto->buscar_ubicacion($nombre); // crea en tu modelo

          $datos = [];
          while ($row = $rspta->fetch_assoc()) {
              $datos[] = [
                  "nombre_pabellon" => $row["nombre_pabellon"],
                  "fila" => $row["fila"],
                  "columna" => $row["columna"],
                  "imagen" => $row["imagen"]
              ];
          }
          echo json_encode($datos);
          break;

}